#!/bin/bash

exec &> >(tee -a log)
# declare -i stoptime="$(date '+%s') + 60 * 60 * 24"

set_num_active_cores ()
{
	# parameters: all/<num>
	
	local -i NumCores=32
	
	local -i i n
	local proclist="0"
	if [ "x$1" == "xall" ]; then
		n=$NumCores
	else
		n=$1
	fi
	for ((i=1; i<n; ++i)); do
		proclist="$proclist,$i"
	done
	
	export OMP_NUM_THREADS="$n"
	export KMP_AFFINITY="granularity=fine,proclist=[$proclist],explicit"
}

tests ()
{
round="round + 1"
echo "start of round $round"

set_num_active_cores all
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 4)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-size-turbo-off
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 5)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-size-turbo-off
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 6)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-size-turbo-off
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 7)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-size-turbo-off
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 8)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-size-turbo-off
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 9)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-size-turbo-off
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 10)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-size-turbo-off
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 11)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-size-turbo-off
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 12)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-size-turbo-off
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 13)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-size-turbo-off
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 14)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-size-turbo-off
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 15)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-size-turbo-off
set_num_active_cores 1
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 4)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-size-turbo-off
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 5)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-size-turbo-off
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 6)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-size-turbo-off
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 7)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-size-turbo-off
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 8)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-size-turbo-off
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 9)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-size-turbo-off
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 10)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-size-turbo-off
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 11)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-size-turbo-off
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 12)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-size-turbo-off
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 13)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-size-turbo-off
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 14)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-size-turbo-off
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 15)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-size-turbo-off

set_num_active_cores 64
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 14)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-cores-turbo-off
set_num_active_cores 30
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 14)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-cores-turbo-off
set_num_active_cores 28
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 14)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-cores-turbo-off
set_num_active_cores 26
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 14)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-cores-turbo-off
set_num_active_cores 24
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 14)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-cores-turbo-off
set_num_active_cores 22
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 14)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-cores-turbo-off
set_num_active_cores 20
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 14)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-cores-turbo-off
set_num_active_cores 18
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 14)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-cores-turbo-off
set_num_active_cores 16
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 14)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-cores-turbo-off
set_num_active_cores 14
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 14)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-cores-turbo-off
set_num_active_cores 12
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 14)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-cores-turbo-off
set_num_active_cores 10
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 14)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-cores-turbo-off
set_num_active_cores 8
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 14)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-cores-turbo-off
set_num_active_cores 6
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 14)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-cores-turbo-off
set_num_active_cores 4
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 14)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-cores-turbo-off
set_num_active_cores 2
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 14)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-cores-turbo-off

set_num_active_cores all
echo "round $round done"
}

testsklein ()
{
round="round + 1"
echo "start of round $round"

set_num_active_cores all
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 4)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-size-turbo-off
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 5)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-size-turbo-off
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 6)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-size-turbo-off
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 7)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-size-turbo-off
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 8)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-size-turbo-off
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 9)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-size-turbo-off
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 10)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-size-turbo-off
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 11)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-size-turbo-off
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 12)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-size-turbo-off
set_num_active_cores 1
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 4)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-size-turbo-off
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 5)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-size-turbo-off
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 6)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-size-turbo-off
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 7)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-size-turbo-off
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 8)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-size-turbo-off
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 9)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-size-turbo-off
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 10)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-size-turbo-off
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 11)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-size-turbo-off
./matrix_invert.bin "rand_gen eigen_loguni $((2 ** 12)) 10" "mult" stat "invert L" stat "invert SSSSN" stat "invert SnSnSnSN" stat >>results-by-size-turbo-off


set_num_active_cores all
echo "round $round done"
}

echo "start of $0"
declare -i round=0
tests
declare -i round=1
tests
declare -i round=2
tests
for ((k=3;k<30;k++)); do
    round=$k;
    testsklein
done
#while (( stoptime > $(date '+%s') )); do
#	tests
#done








